<!DOCTYPE html>
<html>

<head lang="es">
	<meta charset="utf-8">
	<title>Trabajo en grupo TG3</title>
	<link rel="stylesheet" href="style.css">
	<script type="text/javascript" src="https://gc.kis.v2.scr.kaspersky-labs.com/FD126C42-EBFA-4E12-B309-BB3FDD723AC1/main.js?attr=8xtG45K3n9vnWt-QPM8veFRXbbXmEgtE44Bbu80f-xvyLq7hp6WKyPH3tPIINJelyTSfYh8g-hYr3750aBQSMHkYFueJmYJ-ZBa8xZKuz_MO6J2Gdg2llszh8ewIH818e8C8vkWgcAYfq4UgOKBHYscIEzngciOGL4vBt7e5Qkk" charset="UTF-8"></script><style>
		table,
		th,
		td {
			border: 1px solid black;
		}
	</style>
</head>

<body>
	<header>
		<h1>Desarrollo con Tecnologias Emergentes. Curso 2020-21<br>
			Trabajo TG3 del grupo 8<br>
			Titulo: TG3. Implementar dos tecnologias emergentes: TensorFlow y PyTorch</h1>
	</header>
	<nav>
		<ul>
			<li><a href="#1">1. Informacion general</a></li>
			<li><a href="#2">2. Requisitos de los prototipos a implementar</a></li>
			<li><a href="#3">3. Criterios de comparacion de los prototipos</a></li>
			<li><a href="#4">4. Implementación del prototipo con tecnología A</a></li>
			<li><a href="#5">5. Implementación del prototipo con tecnología B</a></li>
			<li><a href="#6">6. Comparacion de los prototipos</a></li>
			<li><a href="#7">7. Conclusiones</a></li>
		</ul>
	</nav>

	<main>
		<section id=1">
			<h2>1. Informacion general</h2>
			<h3>1.1 Autores</h3>
			<p>Los autores de este trabajo han sido Daniel Alonso Arza, Víctor Mora Mato, Víctor Pernas Merino, Salvador Sobrino Solórzano y Alejandro Hernández Martín.</p>
			<h3>1.2 Proyecto Scrum y repositorio en GitLab</h3>
			<p>En este apartado se debe indicar la URL del proyecto "TG3" en GitLab del grupo:
				<a href="https://gitlab.com/dte2021g08/tg3">https://gitlab.com/dte2021g08/tg3</a>".</p>
			<p>En ese proyecto debera haber un Sprint (Milestone) finalizado con el nombre "TG3".</p>
			<h3>1.3 Burndown chart</h3>
			<p>En este apartado se debe incrustar la imagen del diagrama Burndown final del Sprint TG3.</p>
			<img src="Burndown.png" width="822" height="472">
			<h3>1.4 Presentacion del trabajo</h3>
			<p>En este apartado se debe incluir el enlace al archivo de la presentacion con diapositivas, ubicado en el
				repositorio del proyecto.</p>
			<p><a href="https://universidaddealcala-my.sharepoint.com/:p:/g/personal/daniel_alonsoa_edu_uah_es/EX4tmyqBFNdDrtnAHDZAYm4BQhBGn56nBxc9yogklT42jw?e=TcK8Gw">https://universidaddealcala-my.sharepoint.com/:p:/g/personal/daniel_alonsoa_edu_uah_es/EX4tmyqBFNdDrtnAHDZAYm4BQhBGn56nBxc9yogklT42jw?e=TcK8Gw</a>"</p>
		</section>
		<section id="2">
			<h2>2. Requisitos de los prototipos a implementar</h2>
			<p>NOTA: DEBE HABER MÁS DE 10 REQUISITOS, EN OTRO CASO ESTE APARTADO NO SE CALIFICA.</p>
			<p>El objetivo del proyecto es comparar la implementación de dos prototipos (A y B) en los que se utilicen
				las dos
				tecnologías de los trabajos anteriores, una en cada prototipo.</p>
			<p>Es importante cumplimentar este apartado antes de empezar a implementar el prototipo de cada tecnología,
				porque ambos prototipos deben cumplir los mismos requisitos que se establezcan en este apartado. Si se
				van a
				crear dos equipos de trabajo, uno para cada prototipo, el contenido de este apartado es lo que han de
				compartir ambos equipos como punto de partida.</p>
			<p>Cuanto más detallados sean los requisitos, mayor será la precisión en la comparación que se realizará al
				final del trabajo. Se trata de conseguir dos prototipos con igual funcionalidad, pero utilizando
				diferentes tecnologías.</p>
			<p>Se puede dar libertad a los equipos de desarrollo en cuanto al diseño, pero la funcionalidad debe ser lo
				más parecida posible. Por ejemplo, en el caso de que los prototipos sean aplicaciones, no es necesario
				que los colores utilizados en las pantallas sean exactamente los mismos en ambos prototipos, a no ser
				que los miembros del grupo lo hayan decidido así, en cuyo caso, esos detalles de colores deben incluirse
				en el catálogo de requisitos, para que ambos equipos los cumplan.</p>
			<h3>2.1 Catálogo de requisitos</h3>
			<table>
				<tr>
					<th>Req.</th>
					<th>Descripcion</th>
				</tr>
				<tr>
					<td>01</td>
					<td>Los datos que predice el algoritmo son números enteros.</td>
				</tr>
				<tr>
					<td>02</td>
					<td>El rango de valores que se predicen van del 0 al 9.</td>
				</tr>
				<tr>
					<td>03</td>
					<td>Las librerías utilizadas deben ser compatibles con Python.</td>
				</tr>
				<tr>
					<td>04</td>
					<td>Se utilizarán 60.000 imágenes para el entrenamiento.</td>
				</tr>
				<tr>
					<td>05</td>
					<td>El tamaño de las imágenes será 28x28 en escala de grises con valores [0,255].</td>
				</tr>
				<tr>
					<td>06</td>
					<td>El código debe contener comentarios.</td>
				</tr>
				<tr>
					<td>07</td>
					<td>Se deberá importar numpy para el uso de matrices multidimensionales.</td>
				</tr>
				<tr>
					<td>08</td>
					<td>La versión de Python ha de ser 3.5 o 3.8 para implementar la red neuronal.</td>
				</tr>
				<tr>
					<td>09</td>
					<td>Cada imagen tendrá una etiqueta.</td>
				</tr>
				<tr>
					<td>10</td>
					<td>Los datos deberán estar en forma de vector.</td>
				</tr>
			</table>
		</section>
		<section id="3">
			<h2>3. Criterios de comparacion de los prototipos</h2>
			<p>En el trabajo TG2 se definieron criterios de comparación de las dos tecnologías a nivel teórico.</p>
			<p>En este trabajo hay que definir criterios para la comparación de la implementación de las tecnologías en
				la construcción de los prototipos, cuyos requisitos son los establecidos en el apartado 2.</p>
			<p>Se trata de criterios del tipo “horas empleadas en el desarrollo del sistema”, “velocidad de
				funcionamiento del sistema”, “recursos necesarios”, etc.</p>
			<h3>3.1 Criterio 1: Memoria RAM consumida</h3>
				<ul>
					<li>Nombre del criterio: Memoria RAM consumida</li>
					<li>Descripcion: Cantidad de memoria RAM que se consume al ejecutar el programa.</li>
					<li>Tipo de valor: Numérico (GB/GB).</li>
				</ul>
			<h3>3.2 Criterio 2: Memoria de disco consumida</h4>
				<ul>
					<li>Nombre del criterio: Memoria de disco consumida</li>
					<li>Descripcion: Cantidad de memoria de disco que se consume al ejecutar el programa.</li>
					<li>Tipo de valor: Numérico (GB/GB).</li>
				</ul>
			<h3>3.3 Criterio 3: Tiempo de entrenamiento</h3>
				<ul>
					<li>Nombre del criterio: Tiempo de entrenamiento</li>
					<li>Descripcion: Tiempo que tarda en entrenar el modelo.</li>
					<li>Tipo de valor: Numérico (minutos y segundos).</li>
				</ul>
			<h3>3.4 Criterio 4: Precisión</h4>
				<ul>
					<li>Nombre del criterio: Precisión</li>
					<li>Descripcion: es el porcentaje de aciertos que tiene el algoritmo de predecir.</li>
					<li>Tipo de valor: Numérico (float).</li>
				</ul>
			<h3>3.5 Criterio 5: Tiempo de ejecución</h4>
				<ul>
					<li>Nombre del criterio: Tiempo de ejecución</li>
					<li>Descripcion: tiempo que tarda en ejecutarse el programa entero hasta dar por salida la precisión.</li>
					<li>Tipo de valor: Numérico (minutos y segundos).</li>
				</ul>
			<h3>3.6 Criterio 6: Número de predicciones</h3>
				<ul>
					<li>Nombre del criterio: Número de predicciones.</li>
					<li>Descripcion: Cantidad total de predicciones que la red neuronal es capaz de crear.</li>
					<li>Tipo de valor: Numérico (entero).</li>
				</ul>
			<h3>3.7 Criterio 7: Función de pérdida</h3>
				<ul>
					<li>Nombre del criterio: Función de pérdida.</li>
					<li>Descripcion: Función que indica cómo de buena es la red neuronal, cuanto más alto más pobre.</li>
					<li>Tipo de valor: Númerico (decimal).</li>
				</ul>
			<h3>3.8 Criterio 8: Nivel de desempeño</h3>
				<ul>
					<li>Nombre del criterio: Nivel de desempeño.</li>
					<li>Descripcion: Consiste en el nivel en el que la red neuronal cumple su función y es eficaz.</li>
					<li>Tipo de valor: Númerico (decimal).</li>
				</ul>
			<h3>3.9 Criterio 9: Depuración</h3>
				<ul>
					<li>Nombre del criterio: Depuración.</li>
					<li>Descripcion: Proceso de identificar y corregir errores de programación en la red neuronal.</li>
					<li>Tipo de valor: Nivel.</li>
				</ul>
			<h3>3.10 Criterio 10: RMSE</h3>
				<ul>
					<li>Nombre del criterio: RMSE.</li>
					<li>Descripcion: Medida de uso frecuente de las diferencias entre los valores predichos por la red.</li>
					<li>Tipo de valor: Numérico (decimal).</li>
				</ul>
		</section>

		<section id="4">
			<h2>4. Implementación del prototipo con TensorFlow</h2>
			<p>Toda la documentación del prototipo TensorFlow se encuentra en:
				<a
					href="https://gitlab.com/dte2021g08/tg3/-/tree/master/prototipo-TensorFlow/">https://gitlab.com/dte2021g08/tg3/-/tree/master/prototipo-TensorFlow/</a>.
			</p>
		</section>

		<section id="5">
			<h2>5. Implementación del prototipo con PyTorch</h2>
			<p>Toda la documentación del prototipo PyTorch se encuentra en:
				<a
					href="https://gitlab.com/dte2021g08/tg3/-/tree/master/prototipo-PyTorch/">https://gitlab.com/dte2021g08/tg3/-/tree/master/prototipo-PyTorch/</a>.
			</p>
		</section>

		<section id="6">
			<h2>6. Comparacion de los prototipos</h2>
			<p>Debe incluir al menos una tabla resumen cruzando los criterios y los
				valores de cada tecnología. Con una columna de comentarios sobre la comparación.</p>
			<table>
				<tr>
					<th>Criterio</th>
					<th>Prototipo A</th>
					<th>Prototipo B</th>
					<th>Comentarios</th>

				</tr>
				<tr>
					<td>Memoria RAM consumida</td>
					<td>1,06 GB/12,69 GB</td>
					<td>0,84 GB/12,69 GB</td>
					<td>En este caso gana TensorFlow.</td>
				</tr>
				<tr>
					<td>Memoria de disco consumida</td>
					<td>38,61 GB/107,77 GB</td>
					<td>38,71 GB/107,77 GB</td>
					<td>En este caso es similar.</td>
				</tr>
				<tr>
					<td>Tiempo de entrenamiento</td>
					<td>9 segundos</td>
					<td>45 segundos</td>
					<td>TensorFlow tarda menos en entrenarlo.</td>
				</tr>
				<tr>
					<td>Precisión</td>
					<td>0.8651</td>
					<td>0.8421</td>
					<td>TensorFlow consigue una mayor precisión.</td>
				</tr>
				<tr>
					<td>Tiempo de ejecución</td>
					<td>11 segundos</td>
					<td>55 segundos</td>
					<td>La primera vez que se ejecutó el de PyTorch tardó mas de 6 minutos. La segunda vez que se ejecutó el tiempo 
						disminuyó notablemente. El tiempo de TensorFlow apenas cambió. TensorFlow tarda bastante menos.</td>
				</tr>
				<tr>
					<td>Número de predicciones</td>
					<td>10000</td>
					<td>60000</td>
					<td>El número de predicciones será mayor en Pytorch.</td>
				</tr>
				<tr>
					<td>Función de pérdida</td>
					<td>0.27</td>
					<td>0.01</td>
					<td>La media de pérdida es menor en Pytorch que TensorFlow.</td>
				</tr>
				<tr>
					<td>Nivel de desempeño</td>
					<td>0.865</td>
					<td>0.89</td>
					<td>El nivel de desempeño es mayor en PyTorch.</td>
				</tr>
				<tr>
					<td>Depuración</td>
					<td>Baja</td>
					<td>Media</td>
					<td>El nivel de depuración es mayor en PyTorch.</td>
				</tr>
				<tr>
					<td>RMSE</td>
					<td>0.0453</td>
					<td>0.0332</td>
					<td>El nivel de depuración es mayor en TensorFlow.</td>
				</tr>
			</table>
		</section>

		<section id="7">
			<h2>7. Conclusiones</h2>
			<p>A partir de la información que se ha ido aportando a lo largo de esta página, observando los programas en ejecución,
				los criterios de los prototipos elegidos para que en el apartado 6 sean comparados y viendo estas comparaciones, podemos sacar las siguientes conclusiones: 

			</p>
			<td><ul>
				<li>1. En primer lugar, una de las principales conclusiones generales que hemos sacado, es que Google Colab, herramienta software elegida en anteriores trabajos, resulta ser
					un entorno de trabajo mucho más adeuado para trabajar con TensorFlow, ya que ambos pertenecen a la misma compañía.</li>
				<li>2. Otra de las principales conclusiones que podemos sacar al simple vista es el número de líneas de código que se han requerido y TensorFlow requiere menos líneas de código que PyTroch.</li>
				<li>3. La tercera conclusión que podemos sacar es que para el tipo de problema que hemos planteado, TensorFlow es mucho más rápido en tiempo de ejecución que Pytorch. En la imagen a continuación se muestran los tiempos
					 de ejecución con TensorFlow y PyTorch respectivamente:</li>
					 <img src="TfTiempo.png" width="303" height="75"><img src="PyTiempo.png" width="347" height="53">
				<li>4. La cuarta conclusión que vamos a reseñar, es del uso de los recursos. Ejecutando ambos programas podemos ver que TensorFlow consume 1.1 Gb de memoria RAM
					y PyTorch consume 0.84 Gb de RAM. En cambio, de disco, TensorFlow consume 38.61 Gb y PyTorch 38.71 Gb. Lo que podemos concluir es que, aunque haya diferencia en consumo de RAM,
					ninguna de las dos consume demasiada y por tanto no es reseñable para decantarnos por una u otra.</li>
				<li>5. Por último, y no por ello menos importante, podemos decir, viendo las siguientes imágenes, en primer lugar TensorFlow y en segundo PyTorch, que ambas tecnologías son muy precisas, aunque TensorFlow es algo mejor:</li>
					<img src="TfAcc.png" width="749" height="256"><img src="PyAcc.png" width="759" height="246">
			</ul></td>
			<p>Una vez citadas estas 5 conclusiones, podemos decir, que desde nuestra experiencia y punto de vista en este trabajo, creemos que la tecnología más adecuada para solucionar el problema que planteamos es Tensorflow,
				 tanto por velocidad de ejecución y precisión, líneas de código... En definitiva, TensorFlow sería nuestra elegida por encima de PyTorch.
			</p>
		</section>

		

	</main>

</body>

</html>